/*
 *  define.h
 *  LineSelect
 *
 *  Created by 舘 康一 on 11/03/04.
 *  Copyright 2011 Odoru-saboten Workshop. All rights reserved.
 *
 */

// ターゲット>情報を見る>ビルド>GCC 4.0 - Language>Other C Flags=>"-DDEBUG"
#ifdef DEBUG
#define LOG(...) NSLog(__VA_ARGS__);
#define LOG_BOOL(BOOL) NSLog(@"BOOL:%s Value is -> ", #BOOL, BOOL ? @"YES" : @"NO");
#define LOG_CURRENT_LINE_WITH_FILE NSLog(@"%@ line %d", [[NSString stringWithCString:__FILE__] lastPathComponent], __LINE__);
#define LOG_CURRENT_METHOD NSLog(@"%@/%@", NSStringFromClass([self class]), NSStringFromSelector(_cmd));
#define LOG_INT(INT) NSLog(@"    %@/%@(%d)%s = %d", NSStringFromClass([self class]), NSStringFromSelector(_cmd), __LINE__, #INT, INT);
#define LOG_POINT(POINT) NSLog(@"%s x=%0.0f y=%0.0f", #POINT, POINT.x, POINT.y);
#define LOG_RANGE(RANGE) NSLog(@"    %@/%@(%d)%s = Range(loc=%d, len=%d)", NSStringFromClass([self class]), NSStringFromSelector(_cmd), __LINE__, #RANGE, RANGE.location, RANGE.length);
#define LOG_RECT(RECT) NSLog(@"%s: (x=%0.0f, y=%0.0f) w=%0.0f x h=%0.0f", #RECT, RECT.origin.x, RECT.origin.y, RECT.size.width, RECT.size.height);
#define LOG_SIZE(SIZE) NSLog(@"%s: w=%0.0f x h=%0.0f)" , #SIZE, SIZE.width, SIZE.height);
#define LOG_TRACE NSLog(@"%s line %d", __func__, __LINE__);
#define RETURN_BOOL_WITH_LOG(BOOL) NSLog(@"    %@/%@(%d) returned %@ by %s", NSStringFromClass([self class]), NSStringFromSelector(_cmd), __LINE__, BOOL ? @"YES" : @"NO", #BOOL); return BOOL;
#else
#define LOG(...) ;
#define LOG_BOOL(...) ;
#define LOG_CURRENT_LINE_WITH_FILE ;
#define LOG_CURRENT_METHOD ;
#define LOG_INT(...)  ;
#define LOG_POINT(POINT) ;
#define LOG_RANGE(...) ;
#define LOG_RECT(...) ;
#define LOG_SIZE(SIZE) ;
#define LOG_TRACE ;
#define RETURN_BOOL_WITH_LOG(BOOL) return BOOL;
#endif

#define CES_TEXT_VIEW_CLASS_NAME "CETextViewCore"
#define CES_EDITOR_VIEW_CLASS_NAME "CEEditorView"
#define CES_SNIPPETS_FOLDER @"Library/Application Support/CotEditor/Snippets"
#define CES_NOSYNTAX_FOLDER @"noSyntax"
#define CES_UPDATE_SNIPPETS_COMMAND @"update_snip"
#define CES_SNIPPET_EXECUTED YES
#define CES_SNIPPET_NOT_EXECUTED NO


// CotEditor の定数
#define k_key_autoExpandTab     @"autoExpandTab"
#define k_key_tabWidth      	@"tabWidth"
#define k_key_autoIndent		@"autoIndent"
