//
//  CESEditorViewExtension.m
//  CESnippet
//
//  Created by 舘 康一 on 12/01/19.
//  Copyright 2012 Odoru-saboten Workshop. All rights reserved.
//

#import "CESEditorViewExtension.h"


@implementation NSView(CESEditorViewExtension)

// 追加メソッド


// -----------------------------------------------------
// 現在の行番号を返す
- (unsigned int)currentLineNum
// -----------------------------------------------------
{
    // エディタのテキスト全てを得る
    NSString *theString = ([self lineEndingCharacter] == OgreCrLfNewlineCharacter) ? 
                [self stringForSave] : [self string];
    
    // 現在のキャレット位置（あるいは選択位置）を得る
    NSRange theRange = [self selectedRange];
    
    unsigned int theLines = 0, theCurLine = 0, theIndex = 0, theLength = [theString length];
    unsigned int theLineStart = 0, theCountInLine = 0;

    // IM で変換途中の文字列は選択範囲としてカウントしない (2007.05.20)
    if ([[self textView] hasMarkedText]) {
        theRange.length = 0;
    }
    if (theLength > 0) {

        theLineStart = [theString lineRangeForRange:theRange].location;
        
        theCountInLine = theRange.location - theLineStart;

        for (theIndex = 0, theLines = 0; theIndex < theLength; theLines++) {
            if (theIndex <= theRange.location) {
                theCurLine = theLines + 1;
            }
            theIndex = NSMaxRange([theString lineRangeForRange:NSMakeRange(theIndex, 0)]);
        }
    }
    return theLines;;
}

// -----------------------------------------------------
// 現在行全体のテキストを返す
- (NSString *)currentLineText
// -----------------------------------------------------
{
    // エディタのテキスト全てを得る
    NSString *theString = ([self lineEndingCharacter] == OgreCrLfNewlineCharacter) ? 
    [self stringForSave] : [self string];
    
    // 現在のキャレット位置（あるいは選択位置）を得る
    NSRange theRange = [self selectedRange];
    
    unsigned int theLineStart = 0, theLineEnd = 0;
    
    if ([theString length] > 0) {
        
        theLineStart = [theString lineRangeForRange:theRange].location;
        theLineEnd   = NSMaxRange([theString lineRangeForRange:theRange]);
        
        NSRange theLineRange = NSMakeRange(theLineStart, theLineEnd - theLineStart );
        return [theString substringWithRange:theLineRange];
    }
    
    return @"";
}

// -----------------------------------------------------
// 現在の桁番号を返す
- (unsigned int)currentColumn
// -----------------------------------------------------
{
    // エディタのテキスト全てを得る
    NSString *theString = ([self lineEndingCharacter] == OgreCrLfNewlineCharacter) ? 
                [self stringForSave] : [self string];
    
    // 現在のキャレット位置（あるいは選択位置）を得る
    NSRange theRange = [self selectedRange];
    
    unsigned int theLength = [theString length];
    unsigned int theLineStart = 0, theCountInLine = 0;

    // IM で変換途中の文字列は選択範囲としてカウントしない (2007.05.20)
    if (theLength > 0) {

        theLineStart = [theString lineRangeForRange:theRange].location;
        theCountInLine = theRange.location - theLineStart;
    }
    
    return theCountInLine;
}

@end

