//
//  CESnippet.h
//  CESnippet
//
//  Created by 舘 康一 on 11/09/05.
//  Copyright 2011 Odoru-saboten Workshop. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "CESDefine.h"
#import "CESEditorViewExtension.h"


@class CEEditorView;
@class OGRegularExpression;

#pragma mark CETextViewCore header

// CETextViewCore
@interface CETextViewCore : NSTextView
{
//    NSView *_slaveView;
//    NSString *_newLineString;
//    NSDictionary *_typingAttrs;
//    NSColor *_highlightLineColor;
//    
//    NSRect _insertionRect;
//    NSPoint _textContainerOriginPoint;
//    NSRect _highlightLineAdditionalRect;
//    
//    float _lineSpacing;
//    BOOL _isReCompletion;
//    BOOL _updateOutlineMenuItemSelection;
//    BOOL _isSelfDrop;
//    BOOL _isReadingFromPboard;
}

// Public method
//- (NSColor *)highlightLineColor;
//- (void)setHighlightLineColor:(NSColor *)inColor;
//- (void)drawHighlightLineAdditionalRect;
//- (NSRect)highlightLineAdditionalRect;
//- (void)setHighlightLineAdditionalRect:(NSRect)inRect;
- (NSString *)newLineString;
- (void)setNewLineString:(NSString *)inString;
- (NSView *)slaveView;
- (void)setSlaveView:(NSView *)inView;
- (NSDictionary *)typingAttrs;
- (void)setTypingAttrs:(NSDictionary *)inAttrs;
- (void)setEffectTypingAttrs;
- (void)setBackgroundColorWithAlpha:(float)inAlpha;
- (void)replaceSelectedStringTo:(NSString *)inString scroll:(BOOL)inBoolScroll;
- (void)replaceAllStringTo:(NSString *)inString;
- (void)insertAfterSelection:(NSString *)inString;
- (void)appendAllString:(NSString *)inString;
- (void)insertCustomTextWithPatternNum:(int)inPatternNum;
- (void)resetFont:(id)sender;
- (NSArray *)readablePasteboardTypes;
- (NSArray *)pasteboardTypesForString;
- (unsigned int)dragOperationForDraggingInfo:(id <NSDraggingInfo>)inDragInfo type:(NSString *)inType;
- (BOOL)readSelectionFromPasteboard:(NSPasteboard *)inPboard type:(NSString *)inType;
- (NSRange)selectionRangeForProposedRange:(NSRange)inProposedSelRange
                              granularity:(NSSelectionGranularity)inGranularity;
- (BOOL)isSelfDrop;
- (void)setIsSelfDrop:(BOOL)inValue;
- (BOOL)isReadingFromPboard;
- (void)setIsReadingFromPboard:(BOOL)inValue;
- (BOOL)isReCompletion;
- (void)setIsReCompletion:(BOOL)inValue;
- (BOOL)updateOutlineMenuItemSelection;
- (void)setUpdateOutlineMenuItemSelection:(BOOL)inValue;
- (float)lineSpacing;
- (void)setLineSpacing:(float)inLineSpacing;
- (void)setNewLineSpacingAndUpdate:(float)inLineSpacing;
- (void)doReplaceString:(NSString *)inString withRange:(NSRange)inRange 
           withSelected:(NSRange)inSelection withActionName:(NSString *)inActionName;
- (void)selectTextRangeValue:(NSValue *)inRangeValue;

// Action Message
- (IBAction)shiftRight:(id)sender;
- (IBAction)shiftLeft:(id)sender;
- (IBAction)exchangeLowercase:(id)sender;
- (IBAction)exchangeUppercase:(id)sender;
- (IBAction)exchangeCapitalized:(id)sender;
- (IBAction)exchangeFullwidthRoman:(id)sender;
- (IBAction)exchangeHalfwidthRoman:(id)sender;
- (IBAction)exchangeKatakana:(id)sender;
- (IBAction)exchangeHiragana:(id)sender;
- (IBAction)unicodeNormalizationNFD:(id)sender;
- (IBAction)unicodeNormalizationNFC:(id)sender;
- (IBAction)unicodeNormalizationNFKD:(id)sender;
- (IBAction)unicodeNormalizationNFKC:(id)sender;
- (IBAction)unicodeNormalization:(id)sender;
- (IBAction)inputYenMark:(id)sender;
- (IBAction)inputBackSlash:(id)sender;
- (IBAction)editHexColorCodeAsForeColor:(id)sender;
- (IBAction)editHexColorCodeAsBGColor:(id)sender;
- (IBAction)setSelectedRangeWithNSValue:(id)sender;
- (IBAction)setLineSpacingFromMenu:(id)sender;

@end

#pragma mark CESnippet interface

@interface CESnippet : NSObject {
	
    // 初期化時に保持する変数
    
    // 対象の TextView
    CETextViewCore* ceTextView;
    
    // 対象のシンタックス名
    NSString* ceSyntax;
    
    // フォルダから取得したスニペット達を保持する配列
    NSMutableDictionary* snippetsDict;
    
    // ---------------------------------------------------------------------------------------------
    // 実行時に保持する変数
    // ---------------------------------------------------------------------------------------------
    
    // 省略形
    NSMutableString* theTabTrigger;
    
    // 省略形の位置（スニペット実行後の置き換えに使用）
    NSRange abbreviationRange;
    
    // 実行後のスニペット文字列を保持する文字列
    NSMutableString* resultString;
    
    // スニペット実行後のプレースホルダの位置を保持する配列
    NSArray* placeholderRanges;

    // 現在プレイスホルダータブ遷移モードにあるかどうかを保持するブール値
    BOOL _isModeActivate;
    
    // スニペット実行直後のカーソル位置
    NSRange cursorPositionRange;
}

// initialize
+ (CESnippet*)initSnippet:(id)textView;;

// Setter & Getter
- (BOOL)modeActivate;

// Handle Snippet
- (BOOL)executeTabTrigger:(id)sender;
- (void)dealloc;

// - (NSString*)getSnippet:(NSString*)fileName; // タブトリガーを渡してスニペットファイルの内容を取得する
// - (NSString*)executeByTabTrigger:(NSString*)tabTrigger; // タブトリガーを渡してスニペットを実行する
// - (NSString*)executeShellScript:(NSString*)script;
// - (NSArray*)getCandidateByPrefix:(NSString*)prefix; // 候補を探し、配列で返す

@end
